winstd::event_fn_auto_ret< T > Class Template Reference
Event Tracing for Windows API

Helper template to write an event on entry/exit of scope with one parameter (typically result). More...

`#include <WinStd/ETW.h>`

## Public Member Functions

| event_fn_auto_ret (event_provider &ep, const EVENT_DESCRIPTOR *event_cons, const EVENT_DESCRIPTOR *event_dest, LPCSTR pszFnName, T &result)
| Writes the `event_cons` event.
| event_fn_auto_ret (const event_fn_auto_ret< T > &other)
| Copies the object.
| event_fn_auto_ret (event_fn_auto_ret< T > &&other)
| Moves the object.
| ~event_fn_auto_ret ()
| Writes the `event_dest` event.
event_fn_auto_ret & | operator= (const event_fn_auto_ret< T > &other)
| Copies the object.
event_fn_auto_ret & | operator= (event_fn_auto_ret< T > &&other)
| Moves the object.

## Protected Attributes

event_provider & | m_ep
| Reference to event provider in use.
const EVENT_DESCRIPTOR * | m_event_dest
| Event descriptor at destruction.
EVENT_DATA_DESCRIPTOR | m_desc [2]
| Function name and return value.
T & | m_result
| Function result.

## Detailed Description

template<class T>
class winstd::event_fn_auto_ret< T >

Helper template to write an event on entry/exit of scope with one parameter (typically result).

It writes one string event at creation and another at destruction, with allowing one sprintf type parameter for string event at destruction.

The documentation for this class was generated from the following file:

- include/WinStd/ETW.h